#ifndef DOM_BINDINGNAMES_H_
#define DOM_BINDINGNAMES_H_

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioData = 335,
  AudioDecoder = 345,
  AudioDestinationNode = 358,
  AudioEncoder = 379,
  AudioListener = 392,
  AudioNode = 406,
  AudioParam = 416,
  AudioParamMap = 427,
  AudioProcessingEvent = 441,
  AudioScheduledSourceNode = 462,
  AudioTrack = 487,
  AudioTrackList = 498,
  AudioWorklet = 513,
  AudioWorkletGlobalScope = 526,
  AudioWorkletNode = 550,
  AudioWorkletProcessor = 567,
  AuthenticatorAssertionResponse = 589,
  AuthenticatorAttestationResponse = 620,
  AuthenticatorResponse = 653,
  BarProp = 675,
  BaseAudioContext = 683,
  BatteryManager = 700,
  BeforeUnloadEvent = 715,
  BiquadFilterNode = 733,
  Blob = 750,
  BlobEvent = 755,
  BroadcastChannel = 765,
  BrowsingContext = 782,
  BrowsingContextGroup = 798,
  ByteLengthQueuingStrategy = 819,
  CDATASection = 845,
  CSPViolationReportBody = 858,
  CSS = 881,
  CSS2Properties = 885,
  CSSAnimation = 900,
  CSSConditionRule = 913,
  CSSContainerRule = 930,
  CSSCounterStyleRule = 947,
  CSSCustomPropertyRegisteredEvent = 967,
  CSSFontFaceRule = 1000,
  CSSFontFeatureValuesRule = 1016,
  CSSFontPaletteValuesRule = 1041,
  CSSGroupingRule = 1066,
  CSSImportRule = 1082,
  CSSKeyframeRule = 1096,
  CSSKeyframesRule = 1112,
  CSSLayerBlockRule = 1129,
  CSSLayerStatementRule = 1147,
  CSSMarginRule = 1169,
  CSSMediaRule = 1183,
  CSSMozDocumentRule = 1196,
  CSSNamespaceRule = 1215,
  CSSNestedDeclarations = 1232,
  CSSPageDescriptors = 1254,
  CSSPageRule = 1273,
  CSSPositionTryDescriptors = 1285,
  CSSPositionTryRule = 1311,
  CSSPropertyRule = 1330,
  CSSPseudoElement = 1346,
  CSSRule = 1363,
  CSSRuleList = 1371,
  CSSScopeRule = 1383,
  CSSStartingStyleRule = 1396,
  CSSStyleDeclaration = 1417,
  CSSStyleRule = 1437,
  CSSStyleSheet = 1450,
  CSSSupportsRule = 1464,
  CSSTransition = 1480,
  Cache = 1494,
  CacheStorage = 1500,
  CallbackDebuggerNotification = 1513,
  CanonicalBrowsingContext = 1542,
  CanvasCaptureMediaStream = 1567,
  CanvasGradient = 1592,
  CanvasPattern = 1607,
  CanvasRenderingContext2D = 1621,
  CaretPosition = 1646,
  CaretStateChangedEvent = 1660,
  ChannelMergerNode = 1683,
  ChannelSplitterNode = 1701,
  ChannelWrapper = 1721,
  CharacterData = 1736,
  CheckerboardReportService = 1750,
  ChildProcessMessageManager = 1776,
  ChildSHistory = 1803,
  ChromeMessageBroadcaster = 1817,
  ChromeMessageSender = 1842,
  ChromeNodeList = 1862,
  ChromeUtils = 1877,
  ChromeWorker = 1889,
  Client = 1902,
  Clients = 1909,
  Clipboard = 1917,
  ClipboardEvent = 1927,
  ClipboardItem = 1942,
  ClonedErrorHolder = 1956,
  CloseEvent = 1974,
  CloseWatcher = 1985,
  CommandEvent = 1998,
  Comment = 2011,
  CompositionEvent = 2019,
  CompressionStream = 2036,
  ConsoleInstance = 2054,
  ConstantSourceNode = 2070,
  ContentFrameMessageManager = 2089,
  ContentProcessMessageManager = 2116,
  ContentVisibilityAutoStateChangeEvent = 2145,
  ConvolverNode = 2183,
  CookieChangeEvent = 2197,
  CookieStore = 2215,
  CookieStoreManager = 2227,
  CountQueuingStrategy = 2246,
  CreateOfferRequest = 2267,
  Credential = 2286,
  CredentialsContainer = 2297,
  Crypto = 2318,
  CryptoKey = 2325,
  CustomElementRegistry = 2335,
  CustomEvent = 2357,
  CustomStateSet = 2369,
  DOMException = 2384,
  DOMImplementation = 2397,
  DOMLocalization = 2415,
  DOMMatrix = 2431,
  DOMMatrixReadOnly = 2441,
  DOMParser = 2459,
  DOMPoint = 2469,
  DOMPointReadOnly = 2478,
  DOMQuad = 2495,
  DOMRect = 2503,
  DOMRectList = 2511,
  DOMRectReadOnly = 2523,
  DOMStringList = 2539,
  DOMStringMap = 2553,
  DOMTokenList = 2566,
  DataTransfer = 2579,
  DataTransferItem = 2592,
  DataTransferItemList = 2609,
  DebuggerNotification = 2630,
  DebuggerNotificationObserver = 2651,
  DecompressionStream = 2680,
  DedicatedWorkerGlobalScope = 2700,
  DelayNode = 2727,
  DeprecationReportBody = 2737,
  DeviceAcceleration = 2759,
  DeviceLightEvent = 2778,
  DeviceMotionEvent = 2795,
  DeviceOrientationEvent = 2813,
  DeviceRotationRate = 2836,
  Directory = 2855,
  Document = 2865,
  DocumentFragment = 2874,
  DocumentL10n = 2891,
  DocumentTimeline = 2904,
  DocumentType = 2921,
  DominatorTree = 2934,
  DragEvent = 2948,
  DynamicsCompressorNode = 2958,
  EXT_blend_minmax = 2981,
  EXT_color_buffer_float = 2998,
  EXT_color_buffer_half_float = 3021,
  EXT_depth_clamp = 3049,
  EXT_disjoint_timer_query = 3065,
  EXT_float_blend = 3090,
  EXT_frag_depth = 3106,
  EXT_sRGB = 3121,
  EXT_shader_texture_lod = 3130,
  EXT_texture_compression_bptc = 3153,
  EXT_texture_compression_rgtc = 3182,
  EXT_texture_filter_anisotropic = 3211,
  EXT_texture_norm16 = 3242,
  Element = 3261,
  ElementInternals = 3269,
  EncodedAudioChunk = 3286,
  EncodedVideoChunk = 3304,
  ErrorEvent = 3322,
  Event = 3333,
  EventCallbackDebuggerNotification = 3339,
  EventCounts = 3373,
  EventSource = 3385,
  EventTarget = 3397,
  Exception = 3409,
  ExtendableCookieChangeEvent = 3419,
  ExtendableEvent = 3447,
  ExtendableMessageEvent = 3463,
  ExtensionAlarms = 3486,
  ExtensionBrowser = 3502,
  ExtensionBrowserSettings = 3519,
  ExtensionBrowserSettingsColorManagement = 3544,
  ExtensionDns = 3584,
  ExtensionEventManager = 3597,
  ExtensionMockAPI = 3619,
  ExtensionPort = 3636,
  ExtensionProxy = 3650,
  ExtensionRuntime = 3665,
  ExtensionScripting = 3682,
  ExtensionSetting = 3701,
  ExtensionTest = 3718,
  External = 3732,
  FeaturePolicy = 3741,
  FeaturePolicyViolationReportBody = 3755,
  FetchEvent = 3788,
  FetchObserver = 3799,
  File = 3813,
  FileList = 3818,
  FileReader = 3827,
  FileReaderSync = 3838,
  FileSystem = 3853,
  FileSystemDirectoryEntry = 3864,
  FileSystemDirectoryHandle = 3889,
  FileSystemDirectoryHandle_AsyncIterator = 3915,
  FileSystemDirectoryIterator = 3955,
  FileSystemDirectoryReader = 3983,
  FileSystemEntry = 4009,
  FileSystemFileEntry = 4025,
  FileSystemFileHandle = 4045,
  FileSystemHandle = 4066,
  FileSystemSyncAccessHandle = 4083,
  FileSystemWritableFileStream = 4110,
  Flex = 4139,
  FlexItemValues = 4144,
  FlexLineValues = 4159,
  FluentBundle = 4174,
  FluentBundleAsyncIterator = 4187,
  FluentBundleIterator = 4213,
  FluentPattern = 4234,
  FluentResource = 4248,
  FocusEvent = 4263,
  FontFace = 4274,
  FontFaceSet = 4283,
  FontFaceSetIterator = 4295,
  FontFaceSetLoadEvent = 4315,
  FormData = 4336,
  FormData_Iterator = 4345,
  FormDataEvent = 4363,
  FragmentDirective = 4377,
  FrameCrashedEvent = 4395,
  FrameLoader = 4413,
  GPU = 4425,
  GPUAdapter = 4429,
  GPUAdapterInfo = 4440,
  GPUBindGroup = 4455,
  GPUBindGroupLayout = 4468,
  GPUBuffer = 4487,
  GPUBufferUsage = 4497,
  GPUCanvasContext = 4512,
  GPUColorWrite = 4529,
  GPUCommandBuffer = 4543,
  GPUCommandEncoder = 4560,
  GPUCompilationInfo = 4578,
  GPUCompilationMessage = 4597,
  GPUComputePassEncoder = 4619,
  GPUComputePipeline = 4641,
  GPUDevice = 4660,
  GPUDeviceLostInfo = 4670,
  GPUError = 4688,
  GPUExternalTexture = 4697,
  GPUInternalError = 4716,
  GPUMapMode = 4733,
  GPUOutOfMemoryError = 4744,
  GPUPipelineError = 4764,
  GPUPipelineLayout = 4781,
  GPUQuerySet = 4799,
  GPUQueue = 4811,
  GPURenderBundle = 4820,
  GPURenderBundleEncoder = 4836,
  GPURenderPassEncoder = 4859,
  GPURenderPipeline = 4880,
  GPUSampler = 4898,
  GPUShaderModule = 4909,
  GPUShaderStage = 4925,
  GPUSupportedFeatures = 4940,
  GPUSupportedLimits = 4961,
  GPUTexture = 4980,
  GPUTextureUsage = 4991,
  GPUTextureView = 5007,
  GPUUncapturedErrorEvent = 5022,
  GPUValidationError = 5046,
  GainNode = 5065,
  Gamepad = 5074,
  GamepadAxisMoveEvent = 5082,
  GamepadButton = 5103,
  GamepadButtonEvent = 5117,
  GamepadEvent = 5136,
  GamepadHapticActuator = 5149,
  GamepadLightIndicator = 5171,
  GamepadPose = 5193,
  GamepadServiceTest = 5205,
  GamepadTouch = 5224,
  Geolocation = 5237,
  GeolocationCoordinates = 5249,
  GeolocationPosition = 5272,
  GeolocationPositionError = 5292,
  GetUserMediaRequest = 5317,
  GleanBoolean = 5337,
  GleanCategory = 5350,
  GleanCounter = 5364,
  GleanCustomDistribution = 5377,
  GleanDatetime = 5401,
  GleanDenominator = 5415,
  GleanEvent = 5432,
  GleanImpl = 5443,
  GleanLabeled = 5453,
  GleanMemoryDistribution = 5466,
  GleanMetric = 5490,
  GleanNumerator = 5502,
  GleanObject = 5517,
  GleanPingsImpl = 5529,
  GleanQuantity = 5544,
  GleanRate = 5558,
  GleanString = 5568,
  GleanStringList = 5580,
  GleanText = 5596,
  GleanTimespan = 5606,
  GleanTimingDistribution = 5620,
  GleanUrl = 5644,
  GleanUuid = 5653,
  Grid = 5663,
  GridArea = 5668,
  GridDimension = 5677,
  GridLine = 5691,
  GridLines = 5700,
  GridTrack = 5710,
  GridTracks = 5720,
  HTMLAllCollection = 5731,
  HTMLAnchorElement = 5749,
  HTMLAreaElement = 5767,
  HTMLAudioElement = 5783,
  HTMLBRElement = 5800,
  HTMLBaseElement = 5814,
  HTMLBodyElement = 5830,
  HTMLButtonElement = 5846,
  HTMLCanvasElement = 5864,
  HTMLCollection = 5882,
  HTMLDListElement = 5897,
  HTMLDataElement = 5914,
  HTMLDataListElement = 5930,
  HTMLDetailsElement = 5950,
  HTMLDialogElement = 5969,
  HTMLDirectoryElement = 5987,
  HTMLDivElement = 6008,
  HTMLDocument = 6023,
  HTMLElement = 6036,
  HTMLEmbedElement = 6048,
  HTMLFieldSetElement = 6065,
  HTMLFontElement = 6085,
  HTMLFormControlsCollection = 6101,
  HTMLFormElement = 6128,
  HTMLFrameElement = 6144,
  HTMLFrameSetElement = 6161,
  HTMLHRElement = 6181,
  HTMLHeadElement = 6195,
  HTMLHeadingElement = 6211,
  HTMLHtmlElement = 6230,
  HTMLIFrameElement = 6246,
  HTMLImageElement = 6264,
  HTMLInputElement = 6281,
  HTMLLIElement = 6298,
  HTMLLabelElement = 6312,
  HTMLLegendElement = 6329,
  HTMLLinkElement = 6347,
  HTMLMapElement = 6363,
  HTMLMarqueeElement = 6378,
  HTMLMediaElement = 6397,
  HTMLMenuElement = 6414,
  HTMLMetaElement = 6430,
  HTMLMeterElement = 6446,
  HTMLModElement = 6463,
  HTMLOListElement = 6478,
  HTMLObjectElement = 6495,
  HTMLOptGroupElement = 6513,
  HTMLOptionElement = 6533,
  HTMLOptionsCollection = 6551,
  HTMLOutputElement = 6573,
  HTMLParagraphElement = 6591,
  HTMLParamElement = 6612,
  HTMLPictureElement = 6629,
  HTMLPreElement = 6648,
  HTMLProgressElement = 6663,
  HTMLQuoteElement = 6683,
  HTMLScriptElement = 6700,
  HTMLSelectElement = 6718,
  HTMLSlotElement = 6736,
  HTMLSourceElement = 6752,
  HTMLSpanElement = 6770,
  HTMLStyleElement = 6786,
  HTMLTableCaptionElement = 6803,
  HTMLTableCellElement = 6827,
  HTMLTableColElement = 6848,
  HTMLTableElement = 6868,
  HTMLTableRowElement = 6885,
  HTMLTableSectionElement = 6905,
  HTMLTemplateElement = 6929,
  HTMLTextAreaElement = 6949,
  HTMLTimeElement = 6969,
  HTMLTitleElement = 6985,
  HTMLTrackElement = 7002,
  HTMLUListElement = 7019,
  HTMLUnknownElement = 7036,
  HTMLVideoElement = 7055,
  HashChangeEvent = 7072,
  Headers = 7088,
  Headers_Iterator = 7096,
  HeapSnapshot = 7113,
  Highlight = 7126,
  HighlightRegistry = 7136,
  History = 7154,
  IDBCursor = 7162,
  IDBCursorWithValue = 7172,
  IDBDatabase = 7191,
  IDBFactory = 7203,
  IDBIndex = 7214,
  IDBKeyRange = 7223,
  IDBObjectStore = 7235,
  IDBOpenDBRequest = 7250,
  IDBRequest = 7267,
  IDBTransaction = 7278,
  IDBVersionChangeEvent = 7293,
  IIRFilterNode = 7315,
  IOUtils = 7329,
  IdentityCredential = 7337,
  IdleDeadline = 7356,
  Image = 7369,
  ImageBitmap = 7375,
  ImageBitmapRenderingContext = 7387,
  ImageCapture = 7415,
  ImageCaptureError = 7428,
  ImageCaptureErrorEvent = 7446,
  ImageData = 7469,
  ImageDecoder = 7479,
  ImageDocument = 7492,
  ImageTrack = 7506,
  ImageTrackList = 7517,
  InferenceSession = 7532,
  InputEvent = 7549,
  InspectorCSSParser = 7560,
  InspectorFontFace = 7579,
  InspectorUtils = 7597,
  InstallTriggerImpl = 7612,
  IntersectionObserver = 7631,
  IntersectionObserverEntry = 7652,
  IntlUtils = 7678,
  JSProcessActorChild = 7688,
  JSProcessActorParent = 7708,
  JSWindowActorChild = 7729,
  JSWindowActorParent = 7748,
  KeyEvent = 7768,
  KeyboardEvent = 7777,
  KeyframeEffect = 7791,
  L10nFileSource = 7806,
  L10nOverlays = 7821,
  L10nRegistry = 7834,
  LargestContentfulPaint = 7847,
  LegacyMozTCPSocket = 7870,
  Localization = 7889,
  Location = 7902,
  Lock = 7911,
  LockManager = 7916,
  MIDIAccess = 7928,
  MIDIConnectionEvent = 7939,
  MIDIInput = 7959,
  MIDIInputMap = 7969,
  MIDIMessageEvent = 7982,
  MIDIOutput = 7999,
  MIDIOutputMap = 8010,
  MIDIPort = 8024,
  MLS = 8033,
  MLSGroupView = 8037,
  MOZ_debug = 8050,
  MatchGlob = 8060,
  MatchPattern = 8070,
  MatchPatternSet = 8083,
  MathMLElement = 8099,
  MediaCapabilities = 8113,
  MediaControlService = 8131,
  MediaController = 8151,
  MediaDeviceInfo = 8167,
  MediaDevices = 8183,
  MediaElementAudioSourceNode = 8196,
  MediaEncryptedEvent = 8224,
  MediaError = 8244,
  MediaKeyError = 8255,
  MediaKeyMessageEvent = 8269,
  MediaKeySession = 8290,
  MediaKeyStatusMap = 8306,
  MediaKeyStatusMap_Iterator = 8324,
  MediaKeySystemAccess = 8351,
  MediaKeys = 8372,
  MediaList = 8382,
  MediaMetadata = 8392,
  MediaQueryList = 8406,
  MediaQueryListEvent = 8421,
  MediaRecorder = 8441,
  MediaRecorderErrorEvent = 8455,
  MediaSession = 8479,
  MediaSource = 8492,
  MediaStream = 8504,
  MediaStreamAudioDestinationNode = 8516,
  MediaStreamAudioSourceNode = 8548,
  MediaStreamError = 8575,
  MediaStreamEvent = 8592,
  MediaStreamTrack = 8609,
  MediaStreamTrackAudioSourceNode = 8626,
  MediaStreamTrackEvent = 8658,
  MerchantValidationEvent = 8680,
  MessageBroadcaster = 8704,
  MessageChannel = 8723,
  MessageEvent = 8738,
  MessageListenerManager = 8751,
  MessagePort = 8774,
  MessageSender = 8786,
  MimeType = 8800,
  MimeTypeArray = 8809,
  MouseEvent = 8823,
  MouseScrollEvent = 8834,
  MozCanvasPrintState = 8851,
  MozDocumentMatcher = 8871,
  MozDocumentObserver = 8890,
  MozQueryInterface = 8910,
  MozSharedMap = 8928,
  MozSharedMap_Iterator = 8941,
  MozSharedMapChangeEvent = 8963,
  MozStorageAsyncStatementParams = 8987,
  MozStorageStatementParams = 9018,
  MozStorageStatementRow = 9044,
  MozWritableSharedMap = 9067,
  MutationEvent = 9088,
  MutationObserver = 9102,
  MutationRecord = 9119,
  NamedNodeMap = 9134,
  NavigateEvent = 9147,
  Navigation = 9161,
  NavigationActivation = 9172,
  NavigationCurrentEntryChangeEvent = 9193,
  NavigationDestination = 9227,
  NavigationHistoryEntry = 9249,
  NavigationPreloadManager = 9272,
  NavigationTransition = 9297,
  Navigator = 9318,
  NavigatorLogin = 9328,
  NetworkInformation = 9343,
  Node = 9362,
  NodeFilter = 9367,
  NodeIterator = 9378,
  NodeList = 9391,
  Notification = 9400,
  NotificationEvent = 9413,
  NotifyPaintEvent = 9431,
  OES_draw_buffers_indexed = 9448,
  OES_element_index_uint = 9473,
  OES_fbo_render_mipmap = 9496,
  OES_standard_derivatives = 9518,
  OES_texture_float = 9543,
  OES_texture_float_linear = 9561,
  OES_texture_half_float = 9586,
  OES_texture_half_float_linear = 9609,
  OES_vertex_array_object = 9639,
  OVR_multiview2 = 9663,
  OfflineAudioCompletionEvent = 9678,
  OfflineAudioContext = 9706,
  OffscreenCanvas = 9726,
  OffscreenCanvasRenderingContext2D = 9742,
  Option = 9776,
  OscillatorNode = 9783,
  PageTransitionEvent = 9798,
  PaintRequest = 9818,
  PaintRequestList = 9831,
  PaintWorkletGlobalScope = 9848,
  PannerNode = 9872,
  ParentProcessMessageManager = 9883,
  Path2D = 9911,
  PathUtils = 9918,
  PaymentAddress = 9928,
  PaymentMethodChangeEvent = 9943,
  PaymentRequest = 9968,
  PaymentRequestUpdateEvent = 9983,
  PaymentResponse = 10009,
  PeerConnectionImpl = 10025,
  PeerConnectionObserver = 10044,
  Performance = 10067,
  PerformanceEntry = 10079,
  PerformanceEntryEvent = 10096,
  PerformanceEventTiming = 10118,
  PerformanceMark = 10141,
  PerformanceMeasure = 10157,
  PerformanceNavigation = 10176,
  PerformanceNavigationTiming = 10198,
  PerformanceObserver = 10226,
  PerformanceObserverEntryList = 10246,
  PerformancePaintTiming = 10275,
  PerformanceResourceTiming = 10298,
  PerformanceServerTiming = 10324,
  PerformanceTiming = 10348,
  PeriodicWave = 10366,
  PermissionStatus = 10379,
  Permissions = 10396,
  PlacesBookmark = 10408,
  PlacesBookmarkAddition = 10423,
  PlacesBookmarkChanged = 10446,
  PlacesBookmarkGuid = 10468,
  PlacesBookmarkKeyword = 10487,
  PlacesBookmarkMoved = 10509,
  PlacesBookmarkRemoved = 10529,
  PlacesBookmarkTags = 10551,
  PlacesBookmarkTime = 10570,
  PlacesBookmarkTitle = 10589,
  PlacesBookmarkUrl = 10609,
  PlacesEvent = 10627,
  PlacesEventCounts = 10639,
  PlacesFavicon = 10657,
  PlacesHistoryCleared = 10671,
  PlacesObservers = 10692,
  PlacesPurgeCaches = 10708,
  PlacesRanking = 10726,
  PlacesVisit = 10740,
  PlacesVisitRemoved = 10752,
  PlacesVisitTitle = 10771,
  PlacesWeakCallbackWrapper = 10788,
  Plugin = 10814,
  PluginArray = 10821,
  PluginCrashedEvent = 10833,
  PointerEvent = 10852,
  PopStateEvent = 10865,
  PopupBlockedEvent = 10879,
  PopupPositionedEvent = 10897,
  PositionStateEvent = 10918,
  PrecompiledScript = 10937,
  PrivateAttribution = 10955,
  ProcessMessageManager = 10974,
  ProcessingInstruction = 10996,
  ProgressEvent = 11018,
  PromiseDebugging = 11032,
  PromiseNativeHandler = 11049,
  PromiseRejectionEvent = 11070,
  PublicKeyCredential = 11092,
  PushEvent = 11112,
  PushManager = 11122,
  PushManagerImpl = 11134,
  PushMessageData = 11150,
  PushSubscription = 11166,
  PushSubscriptionChangeEvent = 11183,
  PushSubscriptionOptions = 11211,
  RTCCertificate = 11235,
  RTCDTMFSender = 11250,
  RTCDTMFToneChangeEvent = 11264,
  RTCDataChannel = 11287,
  RTCDataChannelEvent = 11302,
  RTCDtlsTransport = 11322,
  RTCEncodedAudioFrame = 11339,
  RTCEncodedVideoFrame = 11360,
  RTCIceCandidate = 11381,
  RTCIceTransport = 11397,
  RTCIdentityProviderRegistrar = 11413,
  RTCPeerConnection = 11442,
  RTCPeerConnectionIceEvent = 11460,
  RTCPeerConnectionStatic = 11486,
  RTCRtpReceiver = 11510,
  RTCRtpScriptTransform = 11525,
  RTCRtpScriptTransformer = 11547,
  RTCRtpSender = 11571,
  RTCRtpTransceiver = 11584,
  RTCSctpTransport = 11602,
  RTCSessionDescription = 11619,
  RTCStatsReport = 11641,
  RTCTrackEvent = 11656,
  RTCTransformEvent = 11670,
  RadioNodeList = 11688,
  Range = 11702,
  ReadableByteStreamController = 11708,
  ReadableStream = 11737,
  ReadableStream_AsyncIterator = 11752,
  ReadableStreamBYOBReader = 11781,
  ReadableStreamBYOBRequest = 11806,
  ReadableStreamDefaultController = 11832,
  ReadableStreamDefaultReader = 11864,
  Report = 11892,
  ReportBody = 11899,
  ReportingObserver = 11910,
  Request = 11928,
  ResizeObserver = 11936,
  ResizeObserverEntry = 11951,
  ResizeObserverSize = 11971,
  Response = 11990,
  SVGAElement = 11999,
  SVGAngle = 12011,
  SVGAnimateElement = 12020,
  SVGAnimateMotionElement = 12038,
  SVGAnimateTransformElement = 12062,
  SVGAnimatedAngle = 12089,
  SVGAnimatedBoolean = 12106,
  SVGAnimatedEnumeration = 12125,
  SVGAnimatedInteger = 12148,
  SVGAnimatedLength = 12167,
  SVGAnimatedLengthList = 12185,
  SVGAnimatedNumber = 12207,
  SVGAnimatedNumberList = 12225,
  SVGAnimatedPreserveAspectRatio = 12247,
  SVGAnimatedRect = 12278,
  SVGAnimatedString = 12294,
  SVGAnimatedTransformList = 12312,
  SVGAnimationElement = 12337,
  SVGCircleElement = 12357,
  SVGClipPathElement = 12374,
  SVGComponentTransferFunctionElement = 12393,
  SVGDefsElement = 12429,
  SVGDescElement = 12444,
  SVGElement = 12459,
  SVGEllipseElement = 12470,
  SVGFEBlendElement = 12488,
  SVGFEColorMatrixElement = 12506,
  SVGFEComponentTransferElement = 12530,
  SVGFECompositeElement = 12560,
  SVGFEConvolveMatrixElement = 12582,
  SVGFEDiffuseLightingElement = 12609,
  SVGFEDisplacementMapElement = 12637,
  SVGFEDistantLightElement = 12665,
  SVGFEDropShadowElement = 12690,
  SVGFEFloodElement = 12713,
  SVGFEFuncAElement = 12731,
  SVGFEFuncBElement = 12749,
  SVGFEFuncGElement = 12767,
  SVGFEFuncRElement = 12785,
  SVGFEGaussianBlurElement = 12803,
  SVGFEImageElement = 12828,
  SVGFEMergeElement = 12846,
  SVGFEMergeNodeElement = 12864,
  SVGFEMorphologyElement = 12886,
  SVGFEOffsetElement = 12909,
  SVGFEPointLightElement = 12928,
  SVGFESpecularLightingElement = 12951,
  SVGFESpotLightElement = 12980,
  SVGFETileElement = 13002,
  SVGFETurbulenceElement = 13019,
  SVGFilterElement = 13042,
  SVGForeignObjectElement = 13059,
  SVGGElement = 13083,
  SVGGeometryElement = 13095,
  SVGGradientElement = 13114,
  SVGGraphicsElement = 13133,
  SVGImageElement = 13152,
  SVGLength = 13168,
  SVGLengthList = 13178,
  SVGLineElement = 13192,
  SVGLinearGradientElement = 13207,
  SVGMPathElement = 13232,
  SVGMarkerElement = 13248,
  SVGMaskElement = 13265,
  SVGMatrix = 13280,
  SVGMetadataElement = 13290,
  SVGNumber = 13309,
  SVGNumberList = 13319,
  SVGPathElement = 13333,
  SVGPathSegment = 13348,
  SVGPatternElement = 13363,
  SVGPoint = 13381,
  SVGPointList = 13390,
  SVGPolygonElement = 13403,
  SVGPolylineElement = 13421,
  SVGPreserveAspectRatio = 13440,
  SVGRadialGradientElement = 13463,
  SVGRect = 13488,
  SVGRectElement = 13496,
  SVGSVGElement = 13511,
  SVGScriptElement = 13525,
  SVGSetElement = 13542,
  SVGStopElement = 13556,
  SVGStringList = 13571,
  SVGStyleElement = 13585,
  SVGSwitchElement = 13601,
  SVGSymbolElement = 13618,
  SVGTSpanElement = 13635,
  SVGTextContentElement = 13651,
  SVGTextElement = 13673,
  SVGTextPathElement = 13688,
  SVGTextPositioningElement = 13707,
  SVGTitleElement = 13733,
  SVGTransform = 13749,
  SVGTransformList = 13762,
  SVGUnitTypes = 13779,
  SVGUseElement = 13792,
  SVGViewElement = 13806,
  Sanitizer = 13821,
  Scheduler = 13831,
  Screen = 13841,
  ScreenLuminance = 13848,
  ScreenOrientation = 13864,
  ScriptProcessorNode = 13882,
  ScrollAreaEvent = 13902,
  SecurityPolicyViolationEvent = 13918,
  Selection = 13947,
  ServiceWorker = 13957,
  ServiceWorkerContainer = 13971,
  ServiceWorkerGlobalScope = 13994,
  ServiceWorkerRegistration = 14019,
  SessionStoreFormData = 14045,
  SessionStoreScrollData = 14066,
  SessionStoreUtils = 14089,
  ShadowRealmGlobalScope = 14107,
  ShadowRoot = 14130,
  SharedWorker = 14141,
  SharedWorkerGlobalScope = 14154,
  SimpleGestureEvent = 14178,
  SourceBuffer = 14197,
  SourceBufferList = 14210,
  SpeechGrammar = 14227,
  SpeechGrammarList = 14241,
  SpeechRecognition = 14259,
  SpeechRecognitionAlternative = 14277,
  SpeechRecognitionError = 14306,
  SpeechRecognitionEvent = 14329,
  SpeechRecognitionResult = 14352,
  SpeechRecognitionResultList = 14376,
  SpeechSynthesis = 14404,
  SpeechSynthesisErrorEvent = 14420,
  SpeechSynthesisEvent = 14446,
  SpeechSynthesisUtterance = 14467,
  SpeechSynthesisVoice = 14492,
  StaticRange = 14513,
  StereoPannerNode = 14525,
  Storage = 14542,
  StorageEvent = 14550,
  StorageManager = 14563,
  StreamFilter = 14578,
  StreamFilterDataEvent = 14591,
  StructuredCloneHolder = 14613,
  StructuredCloneTester = 14635,
  StyleSheet = 14657,
  StyleSheetApplicableStateChangeEvent = 14668,
  StyleSheetList = 14705,
  StyleSheetRemovedEvent = 14720,
  SubmitEvent = 14743,
  SubtleCrypto = 14755,
  SyncMessageSender = 14768,
  SyncReadFile = 14786,
  TCPServerSocket = 14799,
  TCPServerSocketEvent = 14815,
  TCPSocket = 14836,
  TCPSocketErrorEvent = 14846,
  TCPSocketEvent = 14866,
  TaskController = 14881,
  TaskPriorityChangeEvent = 14896,
  TaskSignal = 14920,
  Tensor = 14931,
  TestUtils = 14938,
  TestingDeprecatedInterface = 14948,
  Text = 14975,
  TextClause = 14980,
  TextDecoder = 14991,
  TextDecoderStream = 15003,
  TextEncoder = 15021,
  TextEncoderStream = 15033,
  TextEvent = 15051,
  TextMetrics = 15061,
  TextTrack = 15073,
  TextTrackCue = 15083,
  TextTrackCueList = 15096,
  TextTrackList = 15113,
  TimeEvent = 15127,
  TimeRanges = 15137,
  ToggleEvent = 15148,
  Touch = 15160,
  TouchEvent = 15166,
  TouchList = 15177,
  TrackEvent = 15187,
  TransformStream = 15198,
  TransformStreamDefaultController = 15214,
  TransitionEvent = 15247,
  TreeColumn = 15263,
  TreeColumns = 15274,
  TreeContentView = 15286,
  TreeWalker = 15302,
  TrustedHTML = 15313,
  TrustedScript = 15325,
  TrustedScriptURL = 15339,
  TrustedTypePolicy = 15356,
  TrustedTypePolicyFactory = 15374,
  UDPMessageEvent = 15399,
  UDPSocket = 15415,
  UIEvent = 15425,
  URL = 15433,
  URLSearchParams = 15437,
  URLSearchParams_Iterator = 15453,
  UniFFIPointer = 15478,
  UniFFIScaffolding = 15492,
  UserActivation = 15510,
  UserInteraction = 15525,
  UserProximityEvent = 15541,
  VRDisplay = 15560,
  VRDisplayCapabilities = 15570,
  VRDisplayEvent = 15592,
  VREyeParameters = 15607,
  VRFieldOfView = 15623,
  VRFrameData = 15637,
  VRMockController = 15649,
  VRMockDisplay = 15666,
  VRPose = 15680,
  VRServiceTest = 15687,
  VRStageParameters = 15701,
  VTTCue = 15719,
  VTTRegion = 15726,
  ValidityState = 15736,
  VideoColorSpace = 15750,
  VideoDecoder = 15766,
  VideoEncoder = 15779,
  VideoFrame = 15792,
  VideoPlaybackQuality = 15803,
  VideoTrack = 15824,
  VideoTrackList = 15835,
  ViewTransition = 15850,
  VisualViewport = 15865,
  WEBGL_color_buffer_float = 15880,
  WEBGL_compressed_texture_astc = 15905,
  WEBGL_compressed_texture_etc = 15935,
  WEBGL_compressed_texture_etc1 = 15964,
  WEBGL_compressed_texture_pvrtc = 15994,
  WEBGL_compressed_texture_s3tc = 16025,
  WEBGL_compressed_texture_s3tc_srgb = 16055,
  WEBGL_debug_renderer_info = 16090,
  WEBGL_debug_shaders = 16116,
  WEBGL_depth_texture = 16136,
  WEBGL_draw_buffers = 16156,
  WEBGL_explicit_present = 16175,
  WEBGL_lose_context = 16198,
  WEBGL_provoking_vertex = 16217,
  WGSLLanguageFeatures = 16240,
  WakeLock = 16261,
  WakeLockSentinel = 16270,
  WaveShaperNode = 16287,
  WebExtensionContentScript = 16302,
  WebExtensionPolicy = 16328,
  WebGL2RenderingContext = 16347,
  WebGLActiveInfo = 16370,
  WebGLBuffer = 16386,
  WebGLContextEvent = 16398,
  WebGLFramebuffer = 16416,
  WebGLProgram = 16433,
  WebGLQuery = 16446,
  WebGLRenderbuffer = 16457,
  WebGLRenderingContext = 16475,
  WebGLSampler = 16497,
  WebGLShader = 16510,
  WebGLShaderPrecisionFormat = 16522,
  WebGLSync = 16549,
  WebGLTexture = 16559,
  WebGLTransformFeedback = 16572,
  WebGLUniformLocation = 16595,
  WebGLVertexArrayObject = 16616,
  WebKitCSSMatrix = 16639,
  WebSocket = 16655,
  WebTransport = 16665,
  WebTransportBidirectionalStream = 16678,
  WebTransportDatagramDuplexStream = 16710,
  WebTransportError = 16743,
  WebTransportReceiveStream = 16761,
  WebTransportSendStream = 16787,
  WebrtcGlobalInformation = 16810,
  WheelEvent = 16834,
  Window = 16845,
  WindowClient = 16852,
  WindowContext = 16865,
  WindowGlobalChild = 16879,
  WindowGlobalParent = 16897,
  WindowRoot = 16916,
  Worker = 16927,
  WorkerDebuggerGlobalScope = 16934,
  WorkerGlobalScope = 16960,
  WorkerLocation = 16978,
  WorkerNavigator = 16993,
  WorkerTestUtils = 17009,
  Worklet = 17025,
  WorkletGlobalScope = 17033,
  WritableStream = 17052,
  WritableStreamDefaultController = 17067,
  WritableStreamDefaultWriter = 17099,
  XMLDocument = 17127,
  XMLHttpRequest = 17139,
  XMLHttpRequestEventTarget = 17154,
  XMLHttpRequestUpload = 17180,
  XMLSerializer = 17201,
  XPathEvaluator = 17215,
  XPathExpression = 17230,
  XPathResult = 17246,
  XRBoundedReferenceSpace = 17258,
  XRFrame = 17282,
  XRInputSource = 17290,
  XRInputSourceArray = 17304,
  XRInputSourceEvent = 17323,
  XRInputSourcesChangeEvent = 17342,
  XRPose = 17368,
  XRReferenceSpace = 17375,
  XRReferenceSpaceEvent = 17392,
  XRRenderState = 17414,
  XRRigidTransform = 17428,
  XRSession = 17445,
  XRSessionEvent = 17455,
  XRSpace = 17470,
  XRSystem = 17478,
  XRView = 17487,
  XRViewerPose = 17494,
  XRViewport = 17507,
  XRWebGLLayer = 17518,
  XSLTProcessor = 17531,
  XULCommandEvent = 17545,
  XULElement = 17561,
  XULFrameElement = 17572,
  XULMenuElement = 17588,
  XULPopupElement = 17603,
  XULResizerElement = 17619,
  XULTextElement = 17637,
  XULTreeElement = 17652,
  console = 17667,
  webkitSpeechGrammar = 17675,
  webkitSpeechGrammarList = 17695,
  webkitSpeechRecognition = 17719,
  webkitURL = 17743,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // DOM_BINDINGNAMES_H_
