#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioData" "\0"
  /*   345 */ "AudioDecoder" "\0"
  /*   358 */ "AudioDestinationNode" "\0"
  /*   379 */ "AudioEncoder" "\0"
  /*   392 */ "AudioListener" "\0"
  /*   406 */ "AudioNode" "\0"
  /*   416 */ "AudioParam" "\0"
  /*   427 */ "AudioParamMap" "\0"
  /*   441 */ "AudioProcessingEvent" "\0"
  /*   462 */ "AudioScheduledSourceNode" "\0"
  /*   487 */ "AudioTrack" "\0"
  /*   498 */ "AudioTrackList" "\0"
  /*   513 */ "AudioWorklet" "\0"
  /*   526 */ "AudioWorkletGlobalScope" "\0"
  /*   550 */ "AudioWorkletNode" "\0"
  /*   567 */ "AudioWorkletProcessor" "\0"
  /*   589 */ "AuthenticatorAssertionResponse" "\0"
  /*   620 */ "AuthenticatorAttestationResponse" "\0"
  /*   653 */ "AuthenticatorResponse" "\0"
  /*   675 */ "BarProp" "\0"
  /*   683 */ "BaseAudioContext" "\0"
  /*   700 */ "BatteryManager" "\0"
  /*   715 */ "BeforeUnloadEvent" "\0"
  /*   733 */ "BiquadFilterNode" "\0"
  /*   750 */ "Blob" "\0"
  /*   755 */ "BlobEvent" "\0"
  /*   765 */ "BroadcastChannel" "\0"
  /*   782 */ "BrowsingContext" "\0"
  /*   798 */ "BrowsingContextGroup" "\0"
  /*   819 */ "ByteLengthQueuingStrategy" "\0"
  /*   845 */ "CDATASection" "\0"
  /*   858 */ "CSPViolationReportBody" "\0"
  /*   881 */ "CSS" "\0"
  /*   885 */ "CSS2Properties" "\0"
  /*   900 */ "CSSAnimation" "\0"
  /*   913 */ "CSSConditionRule" "\0"
  /*   930 */ "CSSContainerRule" "\0"
  /*   947 */ "CSSCounterStyleRule" "\0"
  /*   967 */ "CSSCustomPropertyRegisteredEvent" "\0"
  /*  1000 */ "CSSFontFaceRule" "\0"
  /*  1016 */ "CSSFontFeatureValuesRule" "\0"
  /*  1041 */ "CSSFontPaletteValuesRule" "\0"
  /*  1066 */ "CSSGroupingRule" "\0"
  /*  1082 */ "CSSImportRule" "\0"
  /*  1096 */ "CSSKeyframeRule" "\0"
  /*  1112 */ "CSSKeyframesRule" "\0"
  /*  1129 */ "CSSLayerBlockRule" "\0"
  /*  1147 */ "CSSLayerStatementRule" "\0"
  /*  1169 */ "CSSMarginRule" "\0"
  /*  1183 */ "CSSMediaRule" "\0"
  /*  1196 */ "CSSMozDocumentRule" "\0"
  /*  1215 */ "CSSNamespaceRule" "\0"
  /*  1232 */ "CSSNestedDeclarations" "\0"
  /*  1254 */ "CSSPageDescriptors" "\0"
  /*  1273 */ "CSSPageRule" "\0"
  /*  1285 */ "CSSPositionTryDescriptors" "\0"
  /*  1311 */ "CSSPositionTryRule" "\0"
  /*  1330 */ "CSSPropertyRule" "\0"
  /*  1346 */ "CSSPseudoElement" "\0"
  /*  1363 */ "CSSRule" "\0"
  /*  1371 */ "CSSRuleList" "\0"
  /*  1383 */ "CSSScopeRule" "\0"
  /*  1396 */ "CSSStartingStyleRule" "\0"
  /*  1417 */ "CSSStyleDeclaration" "\0"
  /*  1437 */ "CSSStyleRule" "\0"
  /*  1450 */ "CSSStyleSheet" "\0"
  /*  1464 */ "CSSSupportsRule" "\0"
  /*  1480 */ "CSSTransition" "\0"
  /*  1494 */ "Cache" "\0"
  /*  1500 */ "CacheStorage" "\0"
  /*  1513 */ "CallbackDebuggerNotification" "\0"
  /*  1542 */ "CanonicalBrowsingContext" "\0"
  /*  1567 */ "CanvasCaptureMediaStream" "\0"
  /*  1592 */ "CanvasGradient" "\0"
  /*  1607 */ "CanvasPattern" "\0"
  /*  1621 */ "CanvasRenderingContext2D" "\0"
  /*  1646 */ "CaretPosition" "\0"
  /*  1660 */ "CaretStateChangedEvent" "\0"
  /*  1683 */ "ChannelMergerNode" "\0"
  /*  1701 */ "ChannelSplitterNode" "\0"
  /*  1721 */ "ChannelWrapper" "\0"
  /*  1736 */ "CharacterData" "\0"
  /*  1750 */ "CheckerboardReportService" "\0"
  /*  1776 */ "ChildProcessMessageManager" "\0"
  /*  1803 */ "ChildSHistory" "\0"
  /*  1817 */ "ChromeMessageBroadcaster" "\0"
  /*  1842 */ "ChromeMessageSender" "\0"
  /*  1862 */ "ChromeNodeList" "\0"
  /*  1877 */ "ChromeUtils" "\0"
  /*  1889 */ "ChromeWorker" "\0"
  /*  1902 */ "Client" "\0"
  /*  1909 */ "Clients" "\0"
  /*  1917 */ "Clipboard" "\0"
  /*  1927 */ "ClipboardEvent" "\0"
  /*  1942 */ "ClipboardItem" "\0"
  /*  1956 */ "ClonedErrorHolder" "\0"
  /*  1974 */ "CloseEvent" "\0"
  /*  1985 */ "CloseWatcher" "\0"
  /*  1998 */ "CommandEvent" "\0"
  /*  2011 */ "Comment" "\0"
  /*  2019 */ "CompositionEvent" "\0"
  /*  2036 */ "CompressionStream" "\0"
  /*  2054 */ "ConsoleInstance" "\0"
  /*  2070 */ "ConstantSourceNode" "\0"
  /*  2089 */ "ContentFrameMessageManager" "\0"
  /*  2116 */ "ContentProcessMessageManager" "\0"
  /*  2145 */ "ContentVisibilityAutoStateChangeEvent" "\0"
  /*  2183 */ "ConvolverNode" "\0"
  /*  2197 */ "CookieChangeEvent" "\0"
  /*  2215 */ "CookieStore" "\0"
  /*  2227 */ "CookieStoreManager" "\0"
  /*  2246 */ "CountQueuingStrategy" "\0"
  /*  2267 */ "CreateOfferRequest" "\0"
  /*  2286 */ "Credential" "\0"
  /*  2297 */ "CredentialsContainer" "\0"
  /*  2318 */ "Crypto" "\0"
  /*  2325 */ "CryptoKey" "\0"
  /*  2335 */ "CustomElementRegistry" "\0"
  /*  2357 */ "CustomEvent" "\0"
  /*  2369 */ "CustomStateSet" "\0"
  /*  2384 */ "DOMException" "\0"
  /*  2397 */ "DOMImplementation" "\0"
  /*  2415 */ "DOMLocalization" "\0"
  /*  2431 */ "DOMMatrix" "\0"
  /*  2441 */ "DOMMatrixReadOnly" "\0"
  /*  2459 */ "DOMParser" "\0"
  /*  2469 */ "DOMPoint" "\0"
  /*  2478 */ "DOMPointReadOnly" "\0"
  /*  2495 */ "DOMQuad" "\0"
  /*  2503 */ "DOMRect" "\0"
  /*  2511 */ "DOMRectList" "\0"
  /*  2523 */ "DOMRectReadOnly" "\0"
  /*  2539 */ "DOMStringList" "\0"
  /*  2553 */ "DOMStringMap" "\0"
  /*  2566 */ "DOMTokenList" "\0"
  /*  2579 */ "DataTransfer" "\0"
  /*  2592 */ "DataTransferItem" "\0"
  /*  2609 */ "DataTransferItemList" "\0"
  /*  2630 */ "DebuggerNotification" "\0"
  /*  2651 */ "DebuggerNotificationObserver" "\0"
  /*  2680 */ "DecompressionStream" "\0"
  /*  2700 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2727 */ "DelayNode" "\0"
  /*  2737 */ "DeprecationReportBody" "\0"
  /*  2759 */ "DeviceAcceleration" "\0"
  /*  2778 */ "DeviceLightEvent" "\0"
  /*  2795 */ "DeviceMotionEvent" "\0"
  /*  2813 */ "DeviceOrientationEvent" "\0"
  /*  2836 */ "DeviceRotationRate" "\0"
  /*  2855 */ "Directory" "\0"
  /*  2865 */ "Document" "\0"
  /*  2874 */ "DocumentFragment" "\0"
  /*  2891 */ "DocumentL10n" "\0"
  /*  2904 */ "DocumentTimeline" "\0"
  /*  2921 */ "DocumentType" "\0"
  /*  2934 */ "DominatorTree" "\0"
  /*  2948 */ "DragEvent" "\0"
  /*  2958 */ "DynamicsCompressorNode" "\0"
  /*  2981 */ "EXT_blend_minmax" "\0"
  /*  2998 */ "EXT_color_buffer_float" "\0"
  /*  3021 */ "EXT_color_buffer_half_float" "\0"
  /*  3049 */ "EXT_depth_clamp" "\0"
  /*  3065 */ "EXT_disjoint_timer_query" "\0"
  /*  3090 */ "EXT_float_blend" "\0"
  /*  3106 */ "EXT_frag_depth" "\0"
  /*  3121 */ "EXT_sRGB" "\0"
  /*  3130 */ "EXT_shader_texture_lod" "\0"
  /*  3153 */ "EXT_texture_compression_bptc" "\0"
  /*  3182 */ "EXT_texture_compression_rgtc" "\0"
  /*  3211 */ "EXT_texture_filter_anisotropic" "\0"
  /*  3242 */ "EXT_texture_norm16" "\0"
  /*  3261 */ "Element" "\0"
  /*  3269 */ "ElementInternals" "\0"
  /*  3286 */ "EncodedAudioChunk" "\0"
  /*  3304 */ "EncodedVideoChunk" "\0"
  /*  3322 */ "ErrorEvent" "\0"
  /*  3333 */ "Event" "\0"
  /*  3339 */ "EventCallbackDebuggerNotification" "\0"
  /*  3373 */ "EventCounts" "\0"
  /*  3385 */ "EventSource" "\0"
  /*  3397 */ "EventTarget" "\0"
  /*  3409 */ "Exception" "\0"
  /*  3419 */ "ExtendableCookieChangeEvent" "\0"
  /*  3447 */ "ExtendableEvent" "\0"
  /*  3463 */ "ExtendableMessageEvent" "\0"
  /*  3486 */ "ExtensionAlarms" "\0"
  /*  3502 */ "ExtensionBrowser" "\0"
  /*  3519 */ "ExtensionBrowserSettings" "\0"
  /*  3544 */ "ExtensionBrowserSettingsColorManagement" "\0"
  /*  3584 */ "ExtensionDns" "\0"
  /*  3597 */ "ExtensionEventManager" "\0"
  /*  3619 */ "ExtensionMockAPI" "\0"
  /*  3636 */ "ExtensionPort" "\0"
  /*  3650 */ "ExtensionProxy" "\0"
  /*  3665 */ "ExtensionRuntime" "\0"
  /*  3682 */ "ExtensionScripting" "\0"
  /*  3701 */ "ExtensionSetting" "\0"
  /*  3718 */ "ExtensionTest" "\0"
  /*  3732 */ "External" "\0"
  /*  3741 */ "FeaturePolicy" "\0"
  /*  3755 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3788 */ "FetchEvent" "\0"
  /*  3799 */ "FetchObserver" "\0"
  /*  3813 */ "File" "\0"
  /*  3818 */ "FileList" "\0"
  /*  3827 */ "FileReader" "\0"
  /*  3838 */ "FileReaderSync" "\0"
  /*  3853 */ "FileSystem" "\0"
  /*  3864 */ "FileSystemDirectoryEntry" "\0"
  /*  3889 */ "FileSystemDirectoryHandle" "\0"
  /*  3915 */ "FileSystemDirectoryHandle AsyncIterator" "\0"
  /*  3955 */ "FileSystemDirectoryIterator" "\0"
  /*  3983 */ "FileSystemDirectoryReader" "\0"
  /*  4009 */ "FileSystemEntry" "\0"
  /*  4025 */ "FileSystemFileEntry" "\0"
  /*  4045 */ "FileSystemFileHandle" "\0"
  /*  4066 */ "FileSystemHandle" "\0"
  /*  4083 */ "FileSystemSyncAccessHandle" "\0"
  /*  4110 */ "FileSystemWritableFileStream" "\0"
  /*  4139 */ "Flex" "\0"
  /*  4144 */ "FlexItemValues" "\0"
  /*  4159 */ "FlexLineValues" "\0"
  /*  4174 */ "FluentBundle" "\0"
  /*  4187 */ "FluentBundleAsyncIterator" "\0"
  /*  4213 */ "FluentBundleIterator" "\0"
  /*  4234 */ "FluentPattern" "\0"
  /*  4248 */ "FluentResource" "\0"
  /*  4263 */ "FocusEvent" "\0"
  /*  4274 */ "FontFace" "\0"
  /*  4283 */ "FontFaceSet" "\0"
  /*  4295 */ "FontFaceSetIterator" "\0"
  /*  4315 */ "FontFaceSetLoadEvent" "\0"
  /*  4336 */ "FormData" "\0"
  /*  4345 */ "FormData Iterator" "\0"
  /*  4363 */ "FormDataEvent" "\0"
  /*  4377 */ "FragmentDirective" "\0"
  /*  4395 */ "FrameCrashedEvent" "\0"
  /*  4413 */ "FrameLoader" "\0"
  /*  4425 */ "GPU" "\0"
  /*  4429 */ "GPUAdapter" "\0"
  /*  4440 */ "GPUAdapterInfo" "\0"
  /*  4455 */ "GPUBindGroup" "\0"
  /*  4468 */ "GPUBindGroupLayout" "\0"
  /*  4487 */ "GPUBuffer" "\0"
  /*  4497 */ "GPUBufferUsage" "\0"
  /*  4512 */ "GPUCanvasContext" "\0"
  /*  4529 */ "GPUColorWrite" "\0"
  /*  4543 */ "GPUCommandBuffer" "\0"
  /*  4560 */ "GPUCommandEncoder" "\0"
  /*  4578 */ "GPUCompilationInfo" "\0"
  /*  4597 */ "GPUCompilationMessage" "\0"
  /*  4619 */ "GPUComputePassEncoder" "\0"
  /*  4641 */ "GPUComputePipeline" "\0"
  /*  4660 */ "GPUDevice" "\0"
  /*  4670 */ "GPUDeviceLostInfo" "\0"
  /*  4688 */ "GPUError" "\0"
  /*  4697 */ "GPUExternalTexture" "\0"
  /*  4716 */ "GPUInternalError" "\0"
  /*  4733 */ "GPUMapMode" "\0"
  /*  4744 */ "GPUOutOfMemoryError" "\0"
  /*  4764 */ "GPUPipelineError" "\0"
  /*  4781 */ "GPUPipelineLayout" "\0"
  /*  4799 */ "GPUQuerySet" "\0"
  /*  4811 */ "GPUQueue" "\0"
  /*  4820 */ "GPURenderBundle" "\0"
  /*  4836 */ "GPURenderBundleEncoder" "\0"
  /*  4859 */ "GPURenderPassEncoder" "\0"
  /*  4880 */ "GPURenderPipeline" "\0"
  /*  4898 */ "GPUSampler" "\0"
  /*  4909 */ "GPUShaderModule" "\0"
  /*  4925 */ "GPUShaderStage" "\0"
  /*  4940 */ "GPUSupportedFeatures" "\0"
  /*  4961 */ "GPUSupportedLimits" "\0"
  /*  4980 */ "GPUTexture" "\0"
  /*  4991 */ "GPUTextureUsage" "\0"
  /*  5007 */ "GPUTextureView" "\0"
  /*  5022 */ "GPUUncapturedErrorEvent" "\0"
  /*  5046 */ "GPUValidationError" "\0"
  /*  5065 */ "GainNode" "\0"
  /*  5074 */ "Gamepad" "\0"
  /*  5082 */ "GamepadAxisMoveEvent" "\0"
  /*  5103 */ "GamepadButton" "\0"
  /*  5117 */ "GamepadButtonEvent" "\0"
  /*  5136 */ "GamepadEvent" "\0"
  /*  5149 */ "GamepadHapticActuator" "\0"
  /*  5171 */ "GamepadLightIndicator" "\0"
  /*  5193 */ "GamepadPose" "\0"
  /*  5205 */ "GamepadServiceTest" "\0"
  /*  5224 */ "GamepadTouch" "\0"
  /*  5237 */ "Geolocation" "\0"
  /*  5249 */ "GeolocationCoordinates" "\0"
  /*  5272 */ "GeolocationPosition" "\0"
  /*  5292 */ "GeolocationPositionError" "\0"
  /*  5317 */ "GetUserMediaRequest" "\0"
  /*  5337 */ "GleanBoolean" "\0"
  /*  5350 */ "GleanCategory" "\0"
  /*  5364 */ "GleanCounter" "\0"
  /*  5377 */ "GleanCustomDistribution" "\0"
  /*  5401 */ "GleanDatetime" "\0"
  /*  5415 */ "GleanDenominator" "\0"
  /*  5432 */ "GleanEvent" "\0"
  /*  5443 */ "GleanImpl" "\0"
  /*  5453 */ "GleanLabeled" "\0"
  /*  5466 */ "GleanMemoryDistribution" "\0"
  /*  5490 */ "GleanMetric" "\0"
  /*  5502 */ "GleanNumerator" "\0"
  /*  5517 */ "GleanObject" "\0"
  /*  5529 */ "GleanPingsImpl" "\0"
  /*  5544 */ "GleanQuantity" "\0"
  /*  5558 */ "GleanRate" "\0"
  /*  5568 */ "GleanString" "\0"
  /*  5580 */ "GleanStringList" "\0"
  /*  5596 */ "GleanText" "\0"
  /*  5606 */ "GleanTimespan" "\0"
  /*  5620 */ "GleanTimingDistribution" "\0"
  /*  5644 */ "GleanUrl" "\0"
  /*  5653 */ "GleanUuid" "\0"
  /*  5663 */ "Grid" "\0"
  /*  5668 */ "GridArea" "\0"
  /*  5677 */ "GridDimension" "\0"
  /*  5691 */ "GridLine" "\0"
  /*  5700 */ "GridLines" "\0"
  /*  5710 */ "GridTrack" "\0"
  /*  5720 */ "GridTracks" "\0"
  /*  5731 */ "HTMLAllCollection" "\0"
  /*  5749 */ "HTMLAnchorElement" "\0"
  /*  5767 */ "HTMLAreaElement" "\0"
  /*  5783 */ "HTMLAudioElement" "\0"
  /*  5800 */ "HTMLBRElement" "\0"
  /*  5814 */ "HTMLBaseElement" "\0"
  /*  5830 */ "HTMLBodyElement" "\0"
  /*  5846 */ "HTMLButtonElement" "\0"
  /*  5864 */ "HTMLCanvasElement" "\0"
  /*  5882 */ "HTMLCollection" "\0"
  /*  5897 */ "HTMLDListElement" "\0"
  /*  5914 */ "HTMLDataElement" "\0"
  /*  5930 */ "HTMLDataListElement" "\0"
  /*  5950 */ "HTMLDetailsElement" "\0"
  /*  5969 */ "HTMLDialogElement" "\0"
  /*  5987 */ "HTMLDirectoryElement" "\0"
  /*  6008 */ "HTMLDivElement" "\0"
  /*  6023 */ "HTMLDocument" "\0"
  /*  6036 */ "HTMLElement" "\0"
  /*  6048 */ "HTMLEmbedElement" "\0"
  /*  6065 */ "HTMLFieldSetElement" "\0"
  /*  6085 */ "HTMLFontElement" "\0"
  /*  6101 */ "HTMLFormControlsCollection" "\0"
  /*  6128 */ "HTMLFormElement" "\0"
  /*  6144 */ "HTMLFrameElement" "\0"
  /*  6161 */ "HTMLFrameSetElement" "\0"
  /*  6181 */ "HTMLHRElement" "\0"
  /*  6195 */ "HTMLHeadElement" "\0"
  /*  6211 */ "HTMLHeadingElement" "\0"
  /*  6230 */ "HTMLHtmlElement" "\0"
  /*  6246 */ "HTMLIFrameElement" "\0"
  /*  6264 */ "HTMLImageElement" "\0"
  /*  6281 */ "HTMLInputElement" "\0"
  /*  6298 */ "HTMLLIElement" "\0"
  /*  6312 */ "HTMLLabelElement" "\0"
  /*  6329 */ "HTMLLegendElement" "\0"
  /*  6347 */ "HTMLLinkElement" "\0"
  /*  6363 */ "HTMLMapElement" "\0"
  /*  6378 */ "HTMLMarqueeElement" "\0"
  /*  6397 */ "HTMLMediaElement" "\0"
  /*  6414 */ "HTMLMenuElement" "\0"
  /*  6430 */ "HTMLMetaElement" "\0"
  /*  6446 */ "HTMLMeterElement" "\0"
  /*  6463 */ "HTMLModElement" "\0"
  /*  6478 */ "HTMLOListElement" "\0"
  /*  6495 */ "HTMLObjectElement" "\0"
  /*  6513 */ "HTMLOptGroupElement" "\0"
  /*  6533 */ "HTMLOptionElement" "\0"
  /*  6551 */ "HTMLOptionsCollection" "\0"
  /*  6573 */ "HTMLOutputElement" "\0"
  /*  6591 */ "HTMLParagraphElement" "\0"
  /*  6612 */ "HTMLParamElement" "\0"
  /*  6629 */ "HTMLPictureElement" "\0"
  /*  6648 */ "HTMLPreElement" "\0"
  /*  6663 */ "HTMLProgressElement" "\0"
  /*  6683 */ "HTMLQuoteElement" "\0"
  /*  6700 */ "HTMLScriptElement" "\0"
  /*  6718 */ "HTMLSelectElement" "\0"
  /*  6736 */ "HTMLSlotElement" "\0"
  /*  6752 */ "HTMLSourceElement" "\0"
  /*  6770 */ "HTMLSpanElement" "\0"
  /*  6786 */ "HTMLStyleElement" "\0"
  /*  6803 */ "HTMLTableCaptionElement" "\0"
  /*  6827 */ "HTMLTableCellElement" "\0"
  /*  6848 */ "HTMLTableColElement" "\0"
  /*  6868 */ "HTMLTableElement" "\0"
  /*  6885 */ "HTMLTableRowElement" "\0"
  /*  6905 */ "HTMLTableSectionElement" "\0"
  /*  6929 */ "HTMLTemplateElement" "\0"
  /*  6949 */ "HTMLTextAreaElement" "\0"
  /*  6969 */ "HTMLTimeElement" "\0"
  /*  6985 */ "HTMLTitleElement" "\0"
  /*  7002 */ "HTMLTrackElement" "\0"
  /*  7019 */ "HTMLUListElement" "\0"
  /*  7036 */ "HTMLUnknownElement" "\0"
  /*  7055 */ "HTMLVideoElement" "\0"
  /*  7072 */ "HashChangeEvent" "\0"
  /*  7088 */ "Headers" "\0"
  /*  7096 */ "Headers Iterator" "\0"
  /*  7113 */ "HeapSnapshot" "\0"
  /*  7126 */ "Highlight" "\0"
  /*  7136 */ "HighlightRegistry" "\0"
  /*  7154 */ "History" "\0"
  /*  7162 */ "IDBCursor" "\0"
  /*  7172 */ "IDBCursorWithValue" "\0"
  /*  7191 */ "IDBDatabase" "\0"
  /*  7203 */ "IDBFactory" "\0"
  /*  7214 */ "IDBIndex" "\0"
  /*  7223 */ "IDBKeyRange" "\0"
  /*  7235 */ "IDBObjectStore" "\0"
  /*  7250 */ "IDBOpenDBRequest" "\0"
  /*  7267 */ "IDBRequest" "\0"
  /*  7278 */ "IDBTransaction" "\0"
  /*  7293 */ "IDBVersionChangeEvent" "\0"
  /*  7315 */ "IIRFilterNode" "\0"
  /*  7329 */ "IOUtils" "\0"
  /*  7337 */ "IdentityCredential" "\0"
  /*  7356 */ "IdleDeadline" "\0"
  /*  7369 */ "Image" "\0"
  /*  7375 */ "ImageBitmap" "\0"
  /*  7387 */ "ImageBitmapRenderingContext" "\0"
  /*  7415 */ "ImageCapture" "\0"
  /*  7428 */ "ImageCaptureError" "\0"
  /*  7446 */ "ImageCaptureErrorEvent" "\0"
  /*  7469 */ "ImageData" "\0"
  /*  7479 */ "ImageDecoder" "\0"
  /*  7492 */ "ImageDocument" "\0"
  /*  7506 */ "ImageTrack" "\0"
  /*  7517 */ "ImageTrackList" "\0"
  /*  7532 */ "InferenceSession" "\0"
  /*  7549 */ "InputEvent" "\0"
  /*  7560 */ "InspectorCSSParser" "\0"
  /*  7579 */ "InspectorFontFace" "\0"
  /*  7597 */ "InspectorUtils" "\0"
  /*  7612 */ "InstallTriggerImpl" "\0"
  /*  7631 */ "IntersectionObserver" "\0"
  /*  7652 */ "IntersectionObserverEntry" "\0"
  /*  7678 */ "IntlUtils" "\0"
  /*  7688 */ "JSProcessActorChild" "\0"
  /*  7708 */ "JSProcessActorParent" "\0"
  /*  7729 */ "JSWindowActorChild" "\0"
  /*  7748 */ "JSWindowActorParent" "\0"
  /*  7768 */ "KeyEvent" "\0"
  /*  7777 */ "KeyboardEvent" "\0"
  /*  7791 */ "KeyframeEffect" "\0"
  /*  7806 */ "L10nFileSource" "\0"
  /*  7821 */ "L10nOverlays" "\0"
  /*  7834 */ "L10nRegistry" "\0"
  /*  7847 */ "LargestContentfulPaint" "\0"
  /*  7870 */ "LegacyMozTCPSocket" "\0"
  /*  7889 */ "Localization" "\0"
  /*  7902 */ "Location" "\0"
  /*  7911 */ "Lock" "\0"
  /*  7916 */ "LockManager" "\0"
  /*  7928 */ "MIDIAccess" "\0"
  /*  7939 */ "MIDIConnectionEvent" "\0"
  /*  7959 */ "MIDIInput" "\0"
  /*  7969 */ "MIDIInputMap" "\0"
  /*  7982 */ "MIDIMessageEvent" "\0"
  /*  7999 */ "MIDIOutput" "\0"
  /*  8010 */ "MIDIOutputMap" "\0"
  /*  8024 */ "MIDIPort" "\0"
  /*  8033 */ "MLS" "\0"
  /*  8037 */ "MLSGroupView" "\0"
  /*  8050 */ "MOZ_debug" "\0"
  /*  8060 */ "MatchGlob" "\0"
  /*  8070 */ "MatchPattern" "\0"
  /*  8083 */ "MatchPatternSet" "\0"
  /*  8099 */ "MathMLElement" "\0"
  /*  8113 */ "MediaCapabilities" "\0"
  /*  8131 */ "MediaControlService" "\0"
  /*  8151 */ "MediaController" "\0"
  /*  8167 */ "MediaDeviceInfo" "\0"
  /*  8183 */ "MediaDevices" "\0"
  /*  8196 */ "MediaElementAudioSourceNode" "\0"
  /*  8224 */ "MediaEncryptedEvent" "\0"
  /*  8244 */ "MediaError" "\0"
  /*  8255 */ "MediaKeyError" "\0"
  /*  8269 */ "MediaKeyMessageEvent" "\0"
  /*  8290 */ "MediaKeySession" "\0"
  /*  8306 */ "MediaKeyStatusMap" "\0"
  /*  8324 */ "MediaKeyStatusMap Iterator" "\0"
  /*  8351 */ "MediaKeySystemAccess" "\0"
  /*  8372 */ "MediaKeys" "\0"
  /*  8382 */ "MediaList" "\0"
  /*  8392 */ "MediaMetadata" "\0"
  /*  8406 */ "MediaQueryList" "\0"
  /*  8421 */ "MediaQueryListEvent" "\0"
  /*  8441 */ "MediaRecorder" "\0"
  /*  8455 */ "MediaRecorderErrorEvent" "\0"
  /*  8479 */ "MediaSession" "\0"
  /*  8492 */ "MediaSource" "\0"
  /*  8504 */ "MediaStream" "\0"
  /*  8516 */ "MediaStreamAudioDestinationNode" "\0"
  /*  8548 */ "MediaStreamAudioSourceNode" "\0"
  /*  8575 */ "MediaStreamError" "\0"
  /*  8592 */ "MediaStreamEvent" "\0"
  /*  8609 */ "MediaStreamTrack" "\0"
  /*  8626 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  8658 */ "MediaStreamTrackEvent" "\0"
  /*  8680 */ "MerchantValidationEvent" "\0"
  /*  8704 */ "MessageBroadcaster" "\0"
  /*  8723 */ "MessageChannel" "\0"
  /*  8738 */ "MessageEvent" "\0"
  /*  8751 */ "MessageListenerManager" "\0"
  /*  8774 */ "MessagePort" "\0"
  /*  8786 */ "MessageSender" "\0"
  /*  8800 */ "MimeType" "\0"
  /*  8809 */ "MimeTypeArray" "\0"
  /*  8823 */ "MouseEvent" "\0"
  /*  8834 */ "MouseScrollEvent" "\0"
  /*  8851 */ "MozCanvasPrintState" "\0"
  /*  8871 */ "MozDocumentMatcher" "\0"
  /*  8890 */ "MozDocumentObserver" "\0"
  /*  8910 */ "MozQueryInterface" "\0"
  /*  8928 */ "MozSharedMap" "\0"
  /*  8941 */ "MozSharedMap Iterator" "\0"
  /*  8963 */ "MozSharedMapChangeEvent" "\0"
  /*  8987 */ "MozStorageAsyncStatementParams" "\0"
  /*  9018 */ "MozStorageStatementParams" "\0"
  /*  9044 */ "MozStorageStatementRow" "\0"
  /*  9067 */ "MozWritableSharedMap" "\0"
  /*  9088 */ "MutationEvent" "\0"
  /*  9102 */ "MutationObserver" "\0"
  /*  9119 */ "MutationRecord" "\0"
  /*  9134 */ "NamedNodeMap" "\0"
  /*  9147 */ "NavigateEvent" "\0"
  /*  9161 */ "Navigation" "\0"
  /*  9172 */ "NavigationActivation" "\0"
  /*  9193 */ "NavigationCurrentEntryChangeEvent" "\0"
  /*  9227 */ "NavigationDestination" "\0"
  /*  9249 */ "NavigationHistoryEntry" "\0"
  /*  9272 */ "NavigationPreloadManager" "\0"
  /*  9297 */ "NavigationTransition" "\0"
  /*  9318 */ "Navigator" "\0"
  /*  9328 */ "NavigatorLogin" "\0"
  /*  9343 */ "NetworkInformation" "\0"
  /*  9362 */ "Node" "\0"
  /*  9367 */ "NodeFilter" "\0"
  /*  9378 */ "NodeIterator" "\0"
  /*  9391 */ "NodeList" "\0"
  /*  9400 */ "Notification" "\0"
  /*  9413 */ "NotificationEvent" "\0"
  /*  9431 */ "NotifyPaintEvent" "\0"
  /*  9448 */ "OES_draw_buffers_indexed" "\0"
  /*  9473 */ "OES_element_index_uint" "\0"
  /*  9496 */ "OES_fbo_render_mipmap" "\0"
  /*  9518 */ "OES_standard_derivatives" "\0"
  /*  9543 */ "OES_texture_float" "\0"
  /*  9561 */ "OES_texture_float_linear" "\0"
  /*  9586 */ "OES_texture_half_float" "\0"
  /*  9609 */ "OES_texture_half_float_linear" "\0"
  /*  9639 */ "OES_vertex_array_object" "\0"
  /*  9663 */ "OVR_multiview2" "\0"
  /*  9678 */ "OfflineAudioCompletionEvent" "\0"
  /*  9706 */ "OfflineAudioContext" "\0"
  /*  9726 */ "OffscreenCanvas" "\0"
  /*  9742 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  9776 */ "Option" "\0"
  /*  9783 */ "OscillatorNode" "\0"
  /*  9798 */ "PageTransitionEvent" "\0"
  /*  9818 */ "PaintRequest" "\0"
  /*  9831 */ "PaintRequestList" "\0"
  /*  9848 */ "PaintWorkletGlobalScope" "\0"
  /*  9872 */ "PannerNode" "\0"
  /*  9883 */ "ParentProcessMessageManager" "\0"
  /*  9911 */ "Path2D" "\0"
  /*  9918 */ "PathUtils" "\0"
  /*  9928 */ "PaymentAddress" "\0"
  /*  9943 */ "PaymentMethodChangeEvent" "\0"
  /*  9968 */ "PaymentRequest" "\0"
  /*  9983 */ "PaymentRequestUpdateEvent" "\0"
  /* 10009 */ "PaymentResponse" "\0"
  /* 10025 */ "PeerConnectionImpl" "\0"
  /* 10044 */ "PeerConnectionObserver" "\0"
  /* 10067 */ "Performance" "\0"
  /* 10079 */ "PerformanceEntry" "\0"
  /* 10096 */ "PerformanceEntryEvent" "\0"
  /* 10118 */ "PerformanceEventTiming" "\0"
  /* 10141 */ "PerformanceMark" "\0"
  /* 10157 */ "PerformanceMeasure" "\0"
  /* 10176 */ "PerformanceNavigation" "\0"
  /* 10198 */ "PerformanceNavigationTiming" "\0"
  /* 10226 */ "PerformanceObserver" "\0"
  /* 10246 */ "PerformanceObserverEntryList" "\0"
  /* 10275 */ "PerformancePaintTiming" "\0"
  /* 10298 */ "PerformanceResourceTiming" "\0"
  /* 10324 */ "PerformanceServerTiming" "\0"
  /* 10348 */ "PerformanceTiming" "\0"
  /* 10366 */ "PeriodicWave" "\0"
  /* 10379 */ "PermissionStatus" "\0"
  /* 10396 */ "Permissions" "\0"
  /* 10408 */ "PlacesBookmark" "\0"
  /* 10423 */ "PlacesBookmarkAddition" "\0"
  /* 10446 */ "PlacesBookmarkChanged" "\0"
  /* 10468 */ "PlacesBookmarkGuid" "\0"
  /* 10487 */ "PlacesBookmarkKeyword" "\0"
  /* 10509 */ "PlacesBookmarkMoved" "\0"
  /* 10529 */ "PlacesBookmarkRemoved" "\0"
  /* 10551 */ "PlacesBookmarkTags" "\0"
  /* 10570 */ "PlacesBookmarkTime" "\0"
  /* 10589 */ "PlacesBookmarkTitle" "\0"
  /* 10609 */ "PlacesBookmarkUrl" "\0"
  /* 10627 */ "PlacesEvent" "\0"
  /* 10639 */ "PlacesEventCounts" "\0"
  /* 10657 */ "PlacesFavicon" "\0"
  /* 10671 */ "PlacesHistoryCleared" "\0"
  /* 10692 */ "PlacesObservers" "\0"
  /* 10708 */ "PlacesPurgeCaches" "\0"
  /* 10726 */ "PlacesRanking" "\0"
  /* 10740 */ "PlacesVisit" "\0"
  /* 10752 */ "PlacesVisitRemoved" "\0"
  /* 10771 */ "PlacesVisitTitle" "\0"
  /* 10788 */ "PlacesWeakCallbackWrapper" "\0"
  /* 10814 */ "Plugin" "\0"
  /* 10821 */ "PluginArray" "\0"
  /* 10833 */ "PluginCrashedEvent" "\0"
  /* 10852 */ "PointerEvent" "\0"
  /* 10865 */ "PopStateEvent" "\0"
  /* 10879 */ "PopupBlockedEvent" "\0"
  /* 10897 */ "PopupPositionedEvent" "\0"
  /* 10918 */ "PositionStateEvent" "\0"
  /* 10937 */ "PrecompiledScript" "\0"
  /* 10955 */ "PrivateAttribution" "\0"
  /* 10974 */ "ProcessMessageManager" "\0"
  /* 10996 */ "ProcessingInstruction" "\0"
  /* 11018 */ "ProgressEvent" "\0"
  /* 11032 */ "PromiseDebugging" "\0"
  /* 11049 */ "PromiseNativeHandler" "\0"
  /* 11070 */ "PromiseRejectionEvent" "\0"
  /* 11092 */ "PublicKeyCredential" "\0"
  /* 11112 */ "PushEvent" "\0"
  /* 11122 */ "PushManager" "\0"
  /* 11134 */ "PushManagerImpl" "\0"
  /* 11150 */ "PushMessageData" "\0"
  /* 11166 */ "PushSubscription" "\0"
  /* 11183 */ "PushSubscriptionChangeEvent" "\0"
  /* 11211 */ "PushSubscriptionOptions" "\0"
  /* 11235 */ "RTCCertificate" "\0"
  /* 11250 */ "RTCDTMFSender" "\0"
  /* 11264 */ "RTCDTMFToneChangeEvent" "\0"
  /* 11287 */ "RTCDataChannel" "\0"
  /* 11302 */ "RTCDataChannelEvent" "\0"
  /* 11322 */ "RTCDtlsTransport" "\0"
  /* 11339 */ "RTCEncodedAudioFrame" "\0"
  /* 11360 */ "RTCEncodedVideoFrame" "\0"
  /* 11381 */ "RTCIceCandidate" "\0"
  /* 11397 */ "RTCIceTransport" "\0"
  /* 11413 */ "RTCIdentityProviderRegistrar" "\0"
  /* 11442 */ "RTCPeerConnection" "\0"
  /* 11460 */ "RTCPeerConnectionIceEvent" "\0"
  /* 11486 */ "RTCPeerConnectionStatic" "\0"
  /* 11510 */ "RTCRtpReceiver" "\0"
  /* 11525 */ "RTCRtpScriptTransform" "\0"
  /* 11547 */ "RTCRtpScriptTransformer" "\0"
  /* 11571 */ "RTCRtpSender" "\0"
  /* 11584 */ "RTCRtpTransceiver" "\0"
  /* 11602 */ "RTCSctpTransport" "\0"
  /* 11619 */ "RTCSessionDescription" "\0"
  /* 11641 */ "RTCStatsReport" "\0"
  /* 11656 */ "RTCTrackEvent" "\0"
  /* 11670 */ "RTCTransformEvent" "\0"
  /* 11688 */ "RadioNodeList" "\0"
  /* 11702 */ "Range" "\0"
  /* 11708 */ "ReadableByteStreamController" "\0"
  /* 11737 */ "ReadableStream" "\0"
  /* 11752 */ "ReadableStream AsyncIterator" "\0"
  /* 11781 */ "ReadableStreamBYOBReader" "\0"
  /* 11806 */ "ReadableStreamBYOBRequest" "\0"
  /* 11832 */ "ReadableStreamDefaultController" "\0"
  /* 11864 */ "ReadableStreamDefaultReader" "\0"
  /* 11892 */ "Report" "\0"
  /* 11899 */ "ReportBody" "\0"
  /* 11910 */ "ReportingObserver" "\0"
  /* 11928 */ "Request" "\0"
  /* 11936 */ "ResizeObserver" "\0"
  /* 11951 */ "ResizeObserverEntry" "\0"
  /* 11971 */ "ResizeObserverSize" "\0"
  /* 11990 */ "Response" "\0"
  /* 11999 */ "SVGAElement" "\0"
  /* 12011 */ "SVGAngle" "\0"
  /* 12020 */ "SVGAnimateElement" "\0"
  /* 12038 */ "SVGAnimateMotionElement" "\0"
  /* 12062 */ "SVGAnimateTransformElement" "\0"
  /* 12089 */ "SVGAnimatedAngle" "\0"
  /* 12106 */ "SVGAnimatedBoolean" "\0"
  /* 12125 */ "SVGAnimatedEnumeration" "\0"
  /* 12148 */ "SVGAnimatedInteger" "\0"
  /* 12167 */ "SVGAnimatedLength" "\0"
  /* 12185 */ "SVGAnimatedLengthList" "\0"
  /* 12207 */ "SVGAnimatedNumber" "\0"
  /* 12225 */ "SVGAnimatedNumberList" "\0"
  /* 12247 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 12278 */ "SVGAnimatedRect" "\0"
  /* 12294 */ "SVGAnimatedString" "\0"
  /* 12312 */ "SVGAnimatedTransformList" "\0"
  /* 12337 */ "SVGAnimationElement" "\0"
  /* 12357 */ "SVGCircleElement" "\0"
  /* 12374 */ "SVGClipPathElement" "\0"
  /* 12393 */ "SVGComponentTransferFunctionElement" "\0"
  /* 12429 */ "SVGDefsElement" "\0"
  /* 12444 */ "SVGDescElement" "\0"
  /* 12459 */ "SVGElement" "\0"
  /* 12470 */ "SVGEllipseElement" "\0"
  /* 12488 */ "SVGFEBlendElement" "\0"
  /* 12506 */ "SVGFEColorMatrixElement" "\0"
  /* 12530 */ "SVGFEComponentTransferElement" "\0"
  /* 12560 */ "SVGFECompositeElement" "\0"
  /* 12582 */ "SVGFEConvolveMatrixElement" "\0"
  /* 12609 */ "SVGFEDiffuseLightingElement" "\0"
  /* 12637 */ "SVGFEDisplacementMapElement" "\0"
  /* 12665 */ "SVGFEDistantLightElement" "\0"
  /* 12690 */ "SVGFEDropShadowElement" "\0"
  /* 12713 */ "SVGFEFloodElement" "\0"
  /* 12731 */ "SVGFEFuncAElement" "\0"
  /* 12749 */ "SVGFEFuncBElement" "\0"
  /* 12767 */ "SVGFEFuncGElement" "\0"
  /* 12785 */ "SVGFEFuncRElement" "\0"
  /* 12803 */ "SVGFEGaussianBlurElement" "\0"
  /* 12828 */ "SVGFEImageElement" "\0"
  /* 12846 */ "SVGFEMergeElement" "\0"
  /* 12864 */ "SVGFEMergeNodeElement" "\0"
  /* 12886 */ "SVGFEMorphologyElement" "\0"
  /* 12909 */ "SVGFEOffsetElement" "\0"
  /* 12928 */ "SVGFEPointLightElement" "\0"
  /* 12951 */ "SVGFESpecularLightingElement" "\0"
  /* 12980 */ "SVGFESpotLightElement" "\0"
  /* 13002 */ "SVGFETileElement" "\0"
  /* 13019 */ "SVGFETurbulenceElement" "\0"
  /* 13042 */ "SVGFilterElement" "\0"
  /* 13059 */ "SVGForeignObjectElement" "\0"
  /* 13083 */ "SVGGElement" "\0"
  /* 13095 */ "SVGGeometryElement" "\0"
  /* 13114 */ "SVGGradientElement" "\0"
  /* 13133 */ "SVGGraphicsElement" "\0"
  /* 13152 */ "SVGImageElement" "\0"
  /* 13168 */ "SVGLength" "\0"
  /* 13178 */ "SVGLengthList" "\0"
  /* 13192 */ "SVGLineElement" "\0"
  /* 13207 */ "SVGLinearGradientElement" "\0"
  /* 13232 */ "SVGMPathElement" "\0"
  /* 13248 */ "SVGMarkerElement" "\0"
  /* 13265 */ "SVGMaskElement" "\0"
  /* 13280 */ "SVGMatrix" "\0"
  /* 13290 */ "SVGMetadataElement" "\0"
  /* 13309 */ "SVGNumber" "\0"
  /* 13319 */ "SVGNumberList" "\0"
  /* 13333 */ "SVGPathElement" "\0"
  /* 13348 */ "SVGPathSegment" "\0"
  /* 13363 */ "SVGPatternElement" "\0"
  /* 13381 */ "SVGPoint" "\0"
  /* 13390 */ "SVGPointList" "\0"
  /* 13403 */ "SVGPolygonElement" "\0"
  /* 13421 */ "SVGPolylineElement" "\0"
  /* 13440 */ "SVGPreserveAspectRatio" "\0"
  /* 13463 */ "SVGRadialGradientElement" "\0"
  /* 13488 */ "SVGRect" "\0"
  /* 13496 */ "SVGRectElement" "\0"
  /* 13511 */ "SVGSVGElement" "\0"
  /* 13525 */ "SVGScriptElement" "\0"
  /* 13542 */ "SVGSetElement" "\0"
  /* 13556 */ "SVGStopElement" "\0"
  /* 13571 */ "SVGStringList" "\0"
  /* 13585 */ "SVGStyleElement" "\0"
  /* 13601 */ "SVGSwitchElement" "\0"
  /* 13618 */ "SVGSymbolElement" "\0"
  /* 13635 */ "SVGTSpanElement" "\0"
  /* 13651 */ "SVGTextContentElement" "\0"
  /* 13673 */ "SVGTextElement" "\0"
  /* 13688 */ "SVGTextPathElement" "\0"
  /* 13707 */ "SVGTextPositioningElement" "\0"
  /* 13733 */ "SVGTitleElement" "\0"
  /* 13749 */ "SVGTransform" "\0"
  /* 13762 */ "SVGTransformList" "\0"
  /* 13779 */ "SVGUnitTypes" "\0"
  /* 13792 */ "SVGUseElement" "\0"
  /* 13806 */ "SVGViewElement" "\0"
  /* 13821 */ "Sanitizer" "\0"
  /* 13831 */ "Scheduler" "\0"
  /* 13841 */ "Screen" "\0"
  /* 13848 */ "ScreenLuminance" "\0"
  /* 13864 */ "ScreenOrientation" "\0"
  /* 13882 */ "ScriptProcessorNode" "\0"
  /* 13902 */ "ScrollAreaEvent" "\0"
  /* 13918 */ "SecurityPolicyViolationEvent" "\0"
  /* 13947 */ "Selection" "\0"
  /* 13957 */ "ServiceWorker" "\0"
  /* 13971 */ "ServiceWorkerContainer" "\0"
  /* 13994 */ "ServiceWorkerGlobalScope" "\0"
  /* 14019 */ "ServiceWorkerRegistration" "\0"
  /* 14045 */ "SessionStoreFormData" "\0"
  /* 14066 */ "SessionStoreScrollData" "\0"
  /* 14089 */ "SessionStoreUtils" "\0"
  /* 14107 */ "ShadowRealmGlobalScope" "\0"
  /* 14130 */ "ShadowRoot" "\0"
  /* 14141 */ "SharedWorker" "\0"
  /* 14154 */ "SharedWorkerGlobalScope" "\0"
  /* 14178 */ "SimpleGestureEvent" "\0"
  /* 14197 */ "SourceBuffer" "\0"
  /* 14210 */ "SourceBufferList" "\0"
  /* 14227 */ "SpeechGrammar" "\0"
  /* 14241 */ "SpeechGrammarList" "\0"
  /* 14259 */ "SpeechRecognition" "\0"
  /* 14277 */ "SpeechRecognitionAlternative" "\0"
  /* 14306 */ "SpeechRecognitionError" "\0"
  /* 14329 */ "SpeechRecognitionEvent" "\0"
  /* 14352 */ "SpeechRecognitionResult" "\0"
  /* 14376 */ "SpeechRecognitionResultList" "\0"
  /* 14404 */ "SpeechSynthesis" "\0"
  /* 14420 */ "SpeechSynthesisErrorEvent" "\0"
  /* 14446 */ "SpeechSynthesisEvent" "\0"
  /* 14467 */ "SpeechSynthesisUtterance" "\0"
  /* 14492 */ "SpeechSynthesisVoice" "\0"
  /* 14513 */ "StaticRange" "\0"
  /* 14525 */ "StereoPannerNode" "\0"
  /* 14542 */ "Storage" "\0"
  /* 14550 */ "StorageEvent" "\0"
  /* 14563 */ "StorageManager" "\0"
  /* 14578 */ "StreamFilter" "\0"
  /* 14591 */ "StreamFilterDataEvent" "\0"
  /* 14613 */ "StructuredCloneHolder" "\0"
  /* 14635 */ "StructuredCloneTester" "\0"
  /* 14657 */ "StyleSheet" "\0"
  /* 14668 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 14705 */ "StyleSheetList" "\0"
  /* 14720 */ "StyleSheetRemovedEvent" "\0"
  /* 14743 */ "SubmitEvent" "\0"
  /* 14755 */ "SubtleCrypto" "\0"
  /* 14768 */ "SyncMessageSender" "\0"
  /* 14786 */ "SyncReadFile" "\0"
  /* 14799 */ "TCPServerSocket" "\0"
  /* 14815 */ "TCPServerSocketEvent" "\0"
  /* 14836 */ "TCPSocket" "\0"
  /* 14846 */ "TCPSocketErrorEvent" "\0"
  /* 14866 */ "TCPSocketEvent" "\0"
  /* 14881 */ "TaskController" "\0"
  /* 14896 */ "TaskPriorityChangeEvent" "\0"
  /* 14920 */ "TaskSignal" "\0"
  /* 14931 */ "Tensor" "\0"
  /* 14938 */ "TestUtils" "\0"
  /* 14948 */ "TestingDeprecatedInterface" "\0"
  /* 14975 */ "Text" "\0"
  /* 14980 */ "TextClause" "\0"
  /* 14991 */ "TextDecoder" "\0"
  /* 15003 */ "TextDecoderStream" "\0"
  /* 15021 */ "TextEncoder" "\0"
  /* 15033 */ "TextEncoderStream" "\0"
  /* 15051 */ "TextEvent" "\0"
  /* 15061 */ "TextMetrics" "\0"
  /* 15073 */ "TextTrack" "\0"
  /* 15083 */ "TextTrackCue" "\0"
  /* 15096 */ "TextTrackCueList" "\0"
  /* 15113 */ "TextTrackList" "\0"
  /* 15127 */ "TimeEvent" "\0"
  /* 15137 */ "TimeRanges" "\0"
  /* 15148 */ "ToggleEvent" "\0"
  /* 15160 */ "Touch" "\0"
  /* 15166 */ "TouchEvent" "\0"
  /* 15177 */ "TouchList" "\0"
  /* 15187 */ "TrackEvent" "\0"
  /* 15198 */ "TransformStream" "\0"
  /* 15214 */ "TransformStreamDefaultController" "\0"
  /* 15247 */ "TransitionEvent" "\0"
  /* 15263 */ "TreeColumn" "\0"
  /* 15274 */ "TreeColumns" "\0"
  /* 15286 */ "TreeContentView" "\0"
  /* 15302 */ "TreeWalker" "\0"
  /* 15313 */ "TrustedHTML" "\0"
  /* 15325 */ "TrustedScript" "\0"
  /* 15339 */ "TrustedScriptURL" "\0"
  /* 15356 */ "TrustedTypePolicy" "\0"
  /* 15374 */ "TrustedTypePolicyFactory" "\0"
  /* 15399 */ "UDPMessageEvent" "\0"
  /* 15415 */ "UDPSocket" "\0"
  /* 15425 */ "UIEvent" "\0"
  /* 15433 */ "URL" "\0"
  /* 15437 */ "URLSearchParams" "\0"
  /* 15453 */ "URLSearchParams Iterator" "\0"
  /* 15478 */ "UniFFIPointer" "\0"
  /* 15492 */ "UniFFIScaffolding" "\0"
  /* 15510 */ "UserActivation" "\0"
  /* 15525 */ "UserInteraction" "\0"
  /* 15541 */ "UserProximityEvent" "\0"
  /* 15560 */ "VRDisplay" "\0"
  /* 15570 */ "VRDisplayCapabilities" "\0"
  /* 15592 */ "VRDisplayEvent" "\0"
  /* 15607 */ "VREyeParameters" "\0"
  /* 15623 */ "VRFieldOfView" "\0"
  /* 15637 */ "VRFrameData" "\0"
  /* 15649 */ "VRMockController" "\0"
  /* 15666 */ "VRMockDisplay" "\0"
  /* 15680 */ "VRPose" "\0"
  /* 15687 */ "VRServiceTest" "\0"
  /* 15701 */ "VRStageParameters" "\0"
  /* 15719 */ "VTTCue" "\0"
  /* 15726 */ "VTTRegion" "\0"
  /* 15736 */ "ValidityState" "\0"
  /* 15750 */ "VideoColorSpace" "\0"
  /* 15766 */ "VideoDecoder" "\0"
  /* 15779 */ "VideoEncoder" "\0"
  /* 15792 */ "VideoFrame" "\0"
  /* 15803 */ "VideoPlaybackQuality" "\0"
  /* 15824 */ "VideoTrack" "\0"
  /* 15835 */ "VideoTrackList" "\0"
  /* 15850 */ "ViewTransition" "\0"
  /* 15865 */ "VisualViewport" "\0"
  /* 15880 */ "WEBGL_color_buffer_float" "\0"
  /* 15905 */ "WEBGL_compressed_texture_astc" "\0"
  /* 15935 */ "WEBGL_compressed_texture_etc" "\0"
  /* 15964 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 15994 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 16025 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 16055 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 16090 */ "WEBGL_debug_renderer_info" "\0"
  /* 16116 */ "WEBGL_debug_shaders" "\0"
  /* 16136 */ "WEBGL_depth_texture" "\0"
  /* 16156 */ "WEBGL_draw_buffers" "\0"
  /* 16175 */ "WEBGL_explicit_present" "\0"
  /* 16198 */ "WEBGL_lose_context" "\0"
  /* 16217 */ "WEBGL_provoking_vertex" "\0"
  /* 16240 */ "WGSLLanguageFeatures" "\0"
  /* 16261 */ "WakeLock" "\0"
  /* 16270 */ "WakeLockSentinel" "\0"
  /* 16287 */ "WaveShaperNode" "\0"
  /* 16302 */ "WebExtensionContentScript" "\0"
  /* 16328 */ "WebExtensionPolicy" "\0"
  /* 16347 */ "WebGL2RenderingContext" "\0"
  /* 16370 */ "WebGLActiveInfo" "\0"
  /* 16386 */ "WebGLBuffer" "\0"
  /* 16398 */ "WebGLContextEvent" "\0"
  /* 16416 */ "WebGLFramebuffer" "\0"
  /* 16433 */ "WebGLProgram" "\0"
  /* 16446 */ "WebGLQuery" "\0"
  /* 16457 */ "WebGLRenderbuffer" "\0"
  /* 16475 */ "WebGLRenderingContext" "\0"
  /* 16497 */ "WebGLSampler" "\0"
  /* 16510 */ "WebGLShader" "\0"
  /* 16522 */ "WebGLShaderPrecisionFormat" "\0"
  /* 16549 */ "WebGLSync" "\0"
  /* 16559 */ "WebGLTexture" "\0"
  /* 16572 */ "WebGLTransformFeedback" "\0"
  /* 16595 */ "WebGLUniformLocation" "\0"
  /* 16616 */ "WebGLVertexArrayObject" "\0"
  /* 16639 */ "WebKitCSSMatrix" "\0"
  /* 16655 */ "WebSocket" "\0"
  /* 16665 */ "WebTransport" "\0"
  /* 16678 */ "WebTransportBidirectionalStream" "\0"
  /* 16710 */ "WebTransportDatagramDuplexStream" "\0"
  /* 16743 */ "WebTransportError" "\0"
  /* 16761 */ "WebTransportReceiveStream" "\0"
  /* 16787 */ "WebTransportSendStream" "\0"
  /* 16810 */ "WebrtcGlobalInformation" "\0"
  /* 16834 */ "WheelEvent" "\0"
  /* 16845 */ "Window" "\0"
  /* 16852 */ "WindowClient" "\0"
  /* 16865 */ "WindowContext" "\0"
  /* 16879 */ "WindowGlobalChild" "\0"
  /* 16897 */ "WindowGlobalParent" "\0"
  /* 16916 */ "WindowRoot" "\0"
  /* 16927 */ "Worker" "\0"
  /* 16934 */ "WorkerDebuggerGlobalScope" "\0"
  /* 16960 */ "WorkerGlobalScope" "\0"
  /* 16978 */ "WorkerLocation" "\0"
  /* 16993 */ "WorkerNavigator" "\0"
  /* 17009 */ "WorkerTestUtils" "\0"
  /* 17025 */ "Worklet" "\0"
  /* 17033 */ "WorkletGlobalScope" "\0"
  /* 17052 */ "WritableStream" "\0"
  /* 17067 */ "WritableStreamDefaultController" "\0"
  /* 17099 */ "WritableStreamDefaultWriter" "\0"
  /* 17127 */ "XMLDocument" "\0"
  /* 17139 */ "XMLHttpRequest" "\0"
  /* 17154 */ "XMLHttpRequestEventTarget" "\0"
  /* 17180 */ "XMLHttpRequestUpload" "\0"
  /* 17201 */ "XMLSerializer" "\0"
  /* 17215 */ "XPathEvaluator" "\0"
  /* 17230 */ "XPathExpression" "\0"
  /* 17246 */ "XPathResult" "\0"
  /* 17258 */ "XRBoundedReferenceSpace" "\0"
  /* 17282 */ "XRFrame" "\0"
  /* 17290 */ "XRInputSource" "\0"
  /* 17304 */ "XRInputSourceArray" "\0"
  /* 17323 */ "XRInputSourceEvent" "\0"
  /* 17342 */ "XRInputSourcesChangeEvent" "\0"
  /* 17368 */ "XRPose" "\0"
  /* 17375 */ "XRReferenceSpace" "\0"
  /* 17392 */ "XRReferenceSpaceEvent" "\0"
  /* 17414 */ "XRRenderState" "\0"
  /* 17428 */ "XRRigidTransform" "\0"
  /* 17445 */ "XRSession" "\0"
  /* 17455 */ "XRSessionEvent" "\0"
  /* 17470 */ "XRSpace" "\0"
  /* 17478 */ "XRSystem" "\0"
  /* 17487 */ "XRView" "\0"
  /* 17494 */ "XRViewerPose" "\0"
  /* 17507 */ "XRViewport" "\0"
  /* 17518 */ "XRWebGLLayer" "\0"
  /* 17531 */ "XSLTProcessor" "\0"
  /* 17545 */ "XULCommandEvent" "\0"
  /* 17561 */ "XULElement" "\0"
  /* 17572 */ "XULFrameElement" "\0"
  /* 17588 */ "XULMenuElement" "\0"
  /* 17603 */ "XULPopupElement" "\0"
  /* 17619 */ "XULResizerElement" "\0"
  /* 17637 */ "XULTextElement" "\0"
  /* 17652 */ "XULTreeElement" "\0"
  /* 17667 */ "console" "\0"
  /* 17675 */ "webkitSpeechGrammar" "\0"
  /* 17695 */ "webkitSpeechGrammarList" "\0"
  /* 17719 */ "webkitSpeechRecognition" "\0"
  /* 17743 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

